SystemOrganization addCategory: #'IS-Calculator'!

ComposableModel subclass: #Calculator
	instanceVariableNames: 'display button0 button1 button2 button3 button4 button5 button6 button7 button8 button9 buttonPlus buttonMinus buttonMult buttonDiv buttonClear buttonDot buttonEqual buttonChange buttonSqr buttonPer previousLabel currentFlag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IS-Calculator'!

!Calculator commentStamp: '<historical>' prior: 0!
A Calculator is a basic calculator (what else could be?) using Spec. Works only in Pharo 3. 
Use me doing:

Calculator new openWithSpec.


ToDo: 
1. get the text in the display with right-alignement.
2. error handling.
3. and make the calculator work flawless, I've only focused on building a UI with Spec.

The basic operation of the calculator is in four steps:
1) A first value is introduced. 
2) An operation selected. This also trigers the first value to be stored as previousLabel and the display reseted.
3) A second value is introduced.
4) If the = button is pressed, the operation is performed and displayed.
!

!Calculator class methodsFor: 'specs' stamp: 'ignaciosniechowski 11/6/2013 18:29'!
defaultSpec

	<spec>

	^ SpecLayout composed
		newColumn: [  :column | column add: #display;
		newRow: [ :row | row 	add: #buttonClear;
								add: #buttonPer;
								add: #buttonChange;
								add: #buttonSqr ] height: 26;
		newRow: [ :row2 | row2 add: #button1;
								 add: #button2; 
								 add: #button3;
								 add: #buttonDiv ] height:26; 
		newRow: [ :row3 | row3 add: #button4;
								 add: #button5;
								 add: #button6;
								 add: #buttonMult ] height: 26; 
		newRow: [  :row4 | row4 add: #button7;
								  add: #button8;
								  add: #button9;
								  add: #buttonMinus ] height: 26;
		newRow: [  :row5 | row5 add: #buttonDot;
								  add: #button0;
								  add: #buttonEqual;
								  add: #buttonPlus ] height: 26.];
		
		yourself.! !

!Calculator class methodsFor: 'specs' stamp: 'ignaciosniechowski 11/6/2013 18:17'!
title

	^ 'Calculator'! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:25'!
button0

	^ button0.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:25'!
button1

	^ button1.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button2

	^ button2.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button3

	^ button3.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button4

	^ button4.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button5

	^ button5.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button6

	^ button6.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/7/2013 00:08'!
button7

	^ button7.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button8

	^ button8.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
button9

	^ button9.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:28'!
buttonChange

	^ buttonChange.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:28'!
buttonClear

	^ buttonClear.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:28'!
buttonDiv

	^ buttonDiv.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:28'!
buttonDot

	^ buttonDot.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:27'!
buttonEqual

	^ buttonEqual.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:27'!
buttonMinus

	^ buttonMinus.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:29'!
buttonMult

	^ buttonMult.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:28'!
buttonPer

	^ buttonPer.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:26'!
buttonPlus

	^ buttonPlus.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:28'!
buttonSqr

	^ buttonSqr.! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:24'!
display

	^ display.! !

!Calculator methodsFor: 'operations' stamp: 'ignaciosniechowski 11/7/2013 00:17'!
divCheck
	"checks if the divisor is zero ifFalse perform the division"
	(display label asNumber == 0)
		ifTrue: [ display label: 'Error' ]
	
		ifFalse: [ display label: 
			(previousLabel / (display label asNumber)) asFloat asString.]
	! !

!Calculator methodsFor: 'check' stamp: 'ignaciosniechowski 11/6/2013 22:38'!
dotCheck
	"Checks whether a float number is already in the display.
	  IfFalse then allow entering a dot"
	
	(display label asNumber isFloat)
		ifFalse: [display label: (display label,'.')].! !

!Calculator methodsFor: 'operations' stamp: 'ignaciosniechowski 11/6/2013 23:56'!
equals
	"this crapy code has to be improved. This nested and entangled set of tests check 
	the flag sent by the button and perform an operation acording to that."
	
	| result |
	(currentFlag == $+)
	ifTrue: [result := (display label asNumber) + previousLabel.
	display label: result asString.];
	ifFalse: [ 
		(currentFlag == $-)
		ifTrue: [ result :=  previousLabel - (display label asNumber).
		display label: result asString. ]
			ifFalse: [ 
				(currentFlag == $x)
				ifTrue: [ result := (display label asNumber) * previousLabel.
				display label: result asString ] 
					ifFalse: [
						(currentFlag == $/)
					      ifTrue: [ self divCheck. ]]]].
	! !

!Calculator methodsFor: 'initialization' stamp: 'ignaciosniechowski 11/7/2013 00:44'!
formatDigitButtons

	"format digit buttons"
	"here the default action concatenates the contents of the actual string with the number pressed, this sequence continues till an operation button is pressed"
	button0
		label: '0';
		action: [ display label: ((display label,'0') asNumber) asString];
		state: true.
		
	button1
		label: '1';
		action:  [ display label: ((display label,'1') asNumber) asString ];
		state: true.
		
	button2
		label: '2';
		action: [ display label: ((display label,'2') asNumber) asString ];
		state: true.
		
	button3
		label: '3';
		action: [ display label: ((display label,'3') asNumber) asString ];
		state: true.
		
	button4
		label: '4';
		action: [ display label: ((display label,'4') asNumber) asString ];
		state: true.
		
	button5
		label: '5';
		action: [ display label: ((display label,'5') asNumber) asString ];
		state: true.

	button6
		label: '6';
		action: [ display label: ((display label,'6') asNumber) asString ];
		state: true.
		
	button7
		label: '7';
		action:[ display label: ((display label,'7') asNumber) asString ];
		state: true.

	button8
		label: '8';
		action: [ display label: ((display label,'8') asNumber) asString ];
		state: true.
		
	button9
		label: '9';
		action: [ display label: ((display label,'9') asNumber) asString ];
		state: true.! !

!Calculator methodsFor: 'initialization' stamp: 'ignaciosniechowski 11/7/2013 08:30'!
formatOtherButtons

	"format other buttons"
	"The default action: for each operation button is to set an operation flag by   
	sending a message with it"
	buttonPlus
		label: '+';
		action: [ self setFlag: $+ ];
		state: true.
		
	buttonMinus
		label: '-';
		action: [ self setFlag: $- ];
		state: true.
		
	buttonMult
		label: 'x';
		action: [ self setFlag: $x ];
		state: true.
		
	buttonDiv
		label: '/';
		action:  [ self setFlag: $/ ];
		state: true.
		
	buttonSqr
		label: 'Sqr';
		action: [self sqrCheck];
		state: true.
		
	"clear the display"	
	buttonClear
		label: 'C';
		action: [ display label: '0' ];
		state: true.

	buttonDot
		label: '.';
		action: [ self dotCheck ];
		state: true.
		
	"here the operation is performed directly here. No additional setps are
	 required"	
	buttonChange
		label: '+/-';
		action: [ display label: (display label asNumber negated asString) ];
		state: true.

	buttonPer
		label: 'Tutor';
		action: [ Transcript open; show: self tutorialText.];
		state: true.
		
	"go to the nasty nested land called 'equals' where bad code lives"	
	buttonEqual
		label: '=';
		action: [ self equals ];
		state: true.! !

!Calculator methodsFor: 'initialization' stamp: 'ignaciosniechowski 11/7/2013 00:02'!
initialExtent

	"Overrrides DisplayObject>>initialExtent in order to get the
	  desired size of the window + (4@4) which is the border"
	

	^  (207@187) + (4@4) ! !

!Calculator methodsFor: 'initialization' stamp: 'ignaciosniechowski 11/6/2013 16:45'!
initialize 

	super initialize.! !

!Calculator methodsFor: 'initialization' stamp: 'ignaciosniechowski 11/7/2013 08:06'!
initializeWidgets
	
	"instantiate the display"
	display			:= self newLabel.
      
	"instantiate digits buttons"
	button0		:= self newButton.
	button1		:= self newButton.			
	button2		:= self newButton.
	button3		:= self newButton.
	button4		:= self newButton.
	button5		:= self newButton.	
	button6		:= self newButton.
	button7		:= self newButton.
	button8		:= self newButton.
	button9		:= self newButton.		
					
	"instantiate operation buttons"
	buttonPlus		:= self newButton.
	buttonMinus 	:= self newButton.
	buttonDiv		:= self newButton.
	buttonMult		:= self newButton.
	buttonSqr		:= self newButton.
	buttonPer		:= self newButton.
	
	"instantiate other buttons"
	buttonDot		:= self newButton.
	buttonEqual	:= self newButton.
	buttonClear	:= self newButton.
	buttonChange 	:= self newButton.
		
	"send a message to self formatDigitButtons to format the buttons"
	self formatDigitButtons.
	
	"send a message to self formatOtherButtons to format those"
	self formatOtherButtons.
	

																		! !

!Calculator methodsFor: 'accessing' stamp: 'ignaciosniechowski 11/6/2013 18:43'!
previousLabel

	^ previousLabel.! !

!Calculator methodsFor: 'operations' stamp: 'ignaciosniechowski 11/7/2013 00:16'!
setFlag: aFlag

	"stores the first value entered"
	previousLabel := (display label) asNumber.
	
	"sets the flag of the operation to be performed"
	currentFlag := aFlag.
	
	"clears the display"
	display label: ''.! !

!Calculator methodsFor: 'check' stamp: 'ignaciosniechowski 11/6/2013 23:54'!
sqrCheck
	"checks if we are atempting to calculate the square root of a negative number"
	(display label asNumber < 0)
		ifTrue: [ display label:'Error' ]
		ifFalse: [ display label: (display label asNumber sqrt asString) ].! !

!Calculator methodsFor: 'tutorial' stamp: 'ignaciosniechowski 11/7/2013 08:57'!
tutorialText
	| aText |
	aText := 'How I built this calculator''s UI using Spec:
	
	1) Create a subclass of ComposableModel
	1.1) On the class side create two methods:
		     		defaultLayout
		      	title
	1.2) On the instance side create the following method: initializateWidgets. 
	       Here is where you instantiate the components of your UI, which will be 
	       arranged in the class-side method defaultLayout.
		 Take a look at Spec-Core-Widgets for a list of available models. I used
		 LabelModel for the display (I wanted a read only display)
		 ButtonModel for the buttons.
		 
		 Also, in this method you can add the format your particular widget will have.
		 In my case, as there were too many widgets I delegated this task in two 
		 other methods: formatOtherButtons and formatDigitButtons.
		
	2) Once you have all the necesary widgets you must build how this widgets will
	    be displayed. You do that using the class-side method defaultLayout.
	2.2) In my case I used a composed SpecLayout because I wanted to, well, compose
		 the calculator using all the widgets I created. Composed layout works very well
		 for this and it''s pretty easy to set-up. You might think of it as a grid with
		 columns and rows.
		
	3) Overriding the window size. In my case the default window size was not appropriate
	   for the calculator. If you have to adjust the window size you have to overrride the
	    initialExtent method.
	
	 4) Making the widgets perform actions.
	 4.1) In the case of buttons you have several selectors:
			label: sets the label of the button, also you have a label which, of course,
					returns the label of that object. 
			state: Boolean. If true, then the button appears as active (you will notice this
				because the button shows a special blue gradient)
			action: Here is where the fun begins and where you decide the action to be 
				performed by the button. Usually it''s a block that when evaluated sends
				some message(s).
				
	5) This is it. I couldn''t find out how to make the display right-aligned. There are several
	     basic things that are not neither implemented nor well-designed. I tried to focus on 
		building the UI with Spec.
	6) Feel free to improve this and to contact me if I can help you with something: You 
	can reach me in the Pharo forum.
	
		Nacho'.
			
	
	^ aText.
	! !
